=== docs/requirements.txt ===
breathe>=4.26
sphinx>=3.4.3,<4.0
sphinx_rtd_theme>=0.5.2
# sphinx_tabs v1.2.1 is required for Sphinx 2
sphinx_tabs>=1.2.1
sphinx_copybutton
javalang
beautifulsoup4
lxml
