=== debian/changelog ===
simgrid (3.30+dfsg-1) unstable; urgency=medium

  * New upstream release: The Sunday Bloody Sunday release.
    - SimDAG is finally removed, fully superseded by S4U
    - New documentation on calibrating MPI
    - The Algorithms tutorial can now be taken in Python
    - (+ many bug fixes and internal refactoring)

 -- Martin Quinson <mquinson@debian.org>  Mon, 31 Jan 2022 00:17:22 +0100
